#ifndef EXEC_IO_I
#define EXEC_IO_I

#include "lists.i"

.globl AbortIO
.globl WaitIO
.globl CheckIO
.globl SendIO
.globl DoIO
.globl CloseDevice
.globl OpenDevice
.globl RemDevice
.globl AddDevice

.globl ReplyMsg
.globl GetMsg
.globl PutMsg
.globl WaitPort
.globl FindPort
.globl DeletePort
.globl CreatePort
.globl AddPort
.globl RemPort
.globl SendTimerReq

mp_Node = 0
mp_Flags = mp_Node+ln_SIZE
mp_SigBit = mp_Flags+1
mp_SigTask = mp_SigBit+1
mp_MsgList = mp_SigTask+4
mp_SIZE = mp_MsgList+lh_SIZE

#define PF_ACTION       3       /* Mask */
#define PA_SIGNAL       0       /* Signal task in mp_SigTask */
#define PA_SOFTINT      1       /* Signal SoftInt in mp_SoftInt/mp_SigTask */
#define PA_IGNORE       2       /* Ignore arrival */

mn_Node = 0
mn_ReplyPort = mn_Node+ln_SIZE	/* Node */
mn_Length = mn_ReplyPort+4	/* ReplyPort * */
mn_SIZE = mn_Length+2		/* UWORD */

tr_Node = 0
tr_Task = tr_Node+ln_SIZE
tr_Ticks = tr_Task+4
tr_SIZE = tr_Ticks+4

#define CMD_INVALID	0
#define CMD_RESET	1
#define CMD_READ	2
#define CMD_WRITE	3
#define CMD_UPDATE	4
#define CMD_CLEAR	5
#define CMD_STOP	6
#define CMD_START	7
#define CMD_FLUSH	8

DEV_BeginIO = -18
DEV_AbortIO = -24

io_Message = 0
io_Device = io_Message+mn_SIZE;
io_Unit = io_Device+4
io_Command = io_Unit+4
io_Error = io_Command+2
io_Actual = io_Error+2
io_Length = io_Actual+4
io_Data = io_Length+4
io_Offset = io_Data+4
io_SIZE = io_Offset+4

#endif
