#ifndef EXEC_LISTS_I
#define EXEC_LISTS_I

.globl Insert	| List routines
.globl AddHead
.globl AddTail
.globl Remove
.globl RemHead
.globl RemTail
.globl Enqueue
.globl NewList
.globl FindName

.globl HeadNode
.globl TailNode
.globl NextNode
.globl PrevNode
	
/* node types */
#define NT_UNKNOWN      0
#define NT_TASK         1       /* Exec task */
#define NT_TIMER	2
#define NT_DELAY	3	/* send only SIGF_DELAY */
#define NT_DEVICE       4
#define NT_PORT         5
#define NT_MESSAGE      6       /* Indicates message currently pending */
#define NT_FREEMSG      7
#define NT_REPLYMSG     8       /* Message has been replied */
#define NT_RESOURCE     9
#define NT_LIBRARY      10
#define NT_SEMAPHORE    11
#define NT_RESIDENT     12	/* struct Program */
#define NT_STARTUP      13      /* run at startup */

#define NT_USER         254     /* User node types work down from here */
#define NT_EXTENDED     255

lh_Head = 0
lh_Tail = 4
lh_TailPred = 8
lh_SIZE = 12

ln_Next = 0
ln_Prev = 4
ln_Type = 8
ln_Pri  = 9
ln_Name = 10
ln_SIZE = 14

lmn_Next = 0
lmn_Prev = 4
lmn_SIZE = 8

#endif
