#ifndef DOS_TAGS_H
#define DOS_TAGS_H

#ifndef TAG_DONE
#define TAG_DONE        0
#endif

/*****************************************************************************/
/* definitions for the System() call */

#define SYS_Dummy       (256)
#define SYS_Input       (SYS_Dummy + 1)  /* specifies the input filehandle  */
#define SYS_Output      (SYS_Dummy + 2)  /* specifies the output filehandle */
#define SYS_Error       (SYS_Dummy + 3)  /* specifies the error filehandle */
#define SYS_Asynch      (SYS_Dummy + 4)  /* asynch, close i/o/e on exit(!) */
#define SYS_CustomShell (SYS_Dummy + 5)  /* send to a specific shell */


/*****************************************************************************/
/* TAG types for CreateNewProcTags */
/* you MUST specify one of NP_Seglist or NP_Entry.  All else is optional. */

#define NP_Dummy        (1000)
#define NP_Seglist      (NP_Dummy + 1) /* seglist of code to run */
#define NP_FreeSeglist  (NP_Dummy + 2) /* free seglist on exit. Def is TRUE*/
#define NP_Entry        (NP_Dummy + 3) /* entry point to run */
#define NP_Input        (NP_Dummy + 4) /* fh - default is Open("NIL:"...) */
#define NP_Output       (NP_Dummy + 5) /* fh - default is Open("NIL:"...) */
#define NP_Error        (NP_Dummy + 8) /* fh - default is Open("NIL:"...) */
#define NP_CloseInput   (NP_Dummy + 6) /* close input filehandle on exit  */
                                       /* default TRUE */
#define NP_CloseOutput  (NP_Dummy + 7) /* close output filehandle on exit */
                                       /* default TRUE */
#define NP_CloseError   (NP_Dummy + 9) /* close error filehandle on exit  */
                                       /* default TRUE */
#define NP_CurrentDir   (NP_Dummy + 10)/* lock - default is parent's dir  */
#define NP_StackSize    (NP_Dummy + 11)/* stacksize for process - def 4000 */
#define NP_Name         (NP_Dummy + 12)/* name for process-def "New Process"*/
#define NP_Priority     (NP_Dummy + 13)/* priority - default same as parent */
#define NP_CopyVars     (NP_Dummy + 17)/* to copy local vars-def TRUE */
#define NP_Cli          (NP_Dummy + 18)/* create cli structure - def FALSE */
#define NP_Path         (NP_Dummy + 19)/* path - default is copy of parents*/

#define NP_Arguments    (NP_Dummy + 21)/* char * */

#endif
