#ifndef STRING_H
#define STRING_H

#include "stddef.h"

char	*strcpy(char *d, const char *s);
char    *strncpy(char *d, const char *s, size_t n);
char	*strcat(char *d, const char *s);
int	strcmp(const char *d, const char *s);
int	strncmp(const char *d, const char *s, size_t count);
size_t  strlen(const char *s);
void    *memcpy(void *d, const void *s, size_t n);
void    *memmove(void *d, const void *s, size_t n);
void    *memset(void *d, int c, size_t n);
char    *strchr(const char *d, char c);
char    *strstr(const char *d, const char *s);
int     memcmp(const char *d, const char *s, size_t n);
void    *memchr(const char *s, char c, size_t n);
char    *strrchr(const char *s, char c);
size_t  strspn(const char *s, const char *t);
size_t  strcspn(const char *s, const char *t);
char    *strpbrk(const char *s, const char *t);

#ifndef __STRICT_ANSI
#define stricmp(d,s) strcasecmp((d),(s))

int	strncasecmp(const char *d, const char *s);
        /* copy s to d and convert to uppercase, s and d may be the same,
	   return d. */
        /* compare two strings, case-insensitive */
int	strcasecmp(const char *d, const char *s);
        /* copy s to d and convert to uppercase, s and d may be the same,
	   return d. */
char    *strtoupper(char *d, const char *s);


#endif

#endif
