#include "../exec/exec_lib.i"

.globl _Disable
.globl _Enable
.globl _Forbid
.globl _Permit
.globl _Wait
.globl _Signal
.globl _AllocSignal
.globl _FreeSignal
.globl _AddIntServer
.globl _RemIntServer
.globl _Cause

_Enable:
	movel	AbsExecBase,A5
	jmp	A5@(LIB_Enable)

_Disable:
	movel	AbsExecBase,A5
	jmp	A5@(LIB_Disable)

_Forbid:
	movel	AbsExecBase,A5
	jmp	A5@(LIB_Forbid)
	
_Permit:
	movel	AbsExecBase,A5
	jmp	A5@(LIB_Permit)

_Wait:
	movel	AbsExecBase,A5
	movel	SP@(4),D0		| Signals to wait for
	jmp	A5@(LIB_Wait)

_Signal:	
	movel	AbsExecBase,A5
	movel	SP@(4),A0		| First parameter - Task *
	movel	SP@(8),D0		| Signals to send
	jmp	A5@(LIB_Signal)

_AllocSignal:	
	movel	AbsExecBase,A5
	jmp	A5@(LIB_AllocSignal)

_FreeSignal:
	movel	AbsExecBase,A5
	movel	SP@(4),D0		| Signal number to free
	jmp	A5@(LIB_FreeSignal)
	
_AddIntServer:
	movel	AbsExecBase,A5
	movel	SP@(4),D0	| vector number
	movel	SP@(8),A1	| struct Interrupt *
	jmp	A5@(LIB_AddIntServer)

_RemIntServer:
	movel	AbsExecBase,A5
	movel	SP@(4),D0	| vector number
	movel	SP@(8),A1	| struct Interrupt *
	jmp	A5@(LIB_RemIntServer)

_Cause:
	movel	AbsExecBase,A5
	movel	SP@(4),D0	| vector number
	jmp	A5@(LIB_Cause)

