#include "stdio.h"
#include <dos/dos_protos.h>

size_t fread(void *ptr, size_t size, size_t nobj, FILE *fp)
{
    size_t read = 0, n = size*nobj;
    char *p = ptr;
    int c;

    if (n <= fp->bufsize && fp->bufmode == _IOFBF)
    {
        while (read++ < n && (c = fgetc(fp)) != EOF)
	    *p++ = c;

        if (fp->eof || fp->error)
            return (read-1) / size;
    }
    else
    {
	if (fp->bufmode == _IOFBF)
	{
	    while (fp->bufpos < fp->bufused && (c = fgetc(fp)) != EOF)
	    {
		read++;
		*p++ = c;
	    }
	    if (fp->eof || fp->error)
		return read / size;
	}

	/* Ok, now the buffer is exhausted, but unc may still be set if */
        /* The previous while()-loop was never executed                 */
	if (fp->unc != -1)
	{
	    *p++ = fp->unc;
	    fp->unc = -1;
	    read++;
	}

	/* If there still is more to read, do it in one piece */
	if (read < n)
	{
	    read += Read(fp->filehandle, p, n-read);

	    /* Is there a problem? */
	    if (read < n)
		return read / size;
	}

    }

    return nobj;
}
