#include "stdio.h"
#include <dos/dos_protos.h>

int fseek(FILE *fp, long offset, int origin)
{
    LONG seekmode;

    __chkabort();

    fp->unc = -1;

    if (!(fp->flags & __FF_BUFISREAD))
	fflush(fp);

    switch (origin)
    {
    case SEEK_SET:
	seekmode = OFFSET_BEGINNING;
	break;
    case SEEK_CUR:
	seekmode = OFFSET_CURRENT;
	if (fp->flags & __FF_BUFISREAD)
	    offset += fp->bufpos - fp->bufused;
	break;
    case SEEK_END:
	seekmode = OFFSET_END;
	break;
    default:
	return EOF;
	break;
    }

    fp->bufpos = 0;
    fp->flags &= ~__FF_BUFISREAD;

    if (Seek(fp->filehandle, offset, seekmode))
    {
	fp->eof = FALSE;
	return 0;
    }
    else
    {
	fp->error = TRUE;
	fp->eof = TRUE;
	return EOF;
    }
}

