#include "stdio.h"
#include <dos/dos_protos.h>

size_t fwrite(const void *ptr, size_t size, size_t nobj, FILE *fp)
{
    size_t written = 0, n = size * nobj;

    if (n < fp->bufsize / 2 && fp->bufmode != _IONBF)
    {
	char *p = (char *)ptr;
        while (written++ < n && fputc(*p++, fp) != EOF); /* empty while */
	if (fp->error)
	    return (written-1) / size;
    }
    else
    {
	if (fflush(fp)) return 0;
	if ((written = Write(fp->filehandle, ptr, n)) != n)
	    return written / size;
    }

    return nobj;
}
