/* stdlib.h */

#include "stddef.h"

#define EXIT_SUCCESS  0
#define EXIT_WARN     5 /* Non-ANSI! */
#define EXIT_ERROR   10 /* Non-ANSI! */
#define EXIT_FAILURE 20

#define atol(s) strtol((s),(char **)0, 10)
#define atoi(s) ((int)strtol((s),(char **)0, 10))
void *malloc(size_t size);
void *calloc(size_t nobj, size_t size);
void *realloc(void *p, size_t newsize);
void free(void *p);
void srand(unsigned int seed);
int rand(void);
#define abs(x) ((int)((x<0) ? -(x) : (x)))
#define labs(x) ((long)((x<0) ? -(x) : (x)))
long strtol(const char *s, char **endp, int base);
#define strtoul(s,e,b) ((unsigned long)strtol((s), (e), (b)))
void qsort(void *base, size_t n, size_t size,
	   int (*cmp)(const void *, const void *));
void *bsearch(const void *key, const void *base,
	      size_t n, size_t size,
	      int (*cmp)(const void *keyval, const void *datum));
char *getenv(const char *name);
void exit(int status); /* This is actually in the c.o module! */
int atexit(void (*fcn)(void));

#ifndef __STRICT_ANSI
#include <string.h>
     /* Writes NULL-terminated environment string contents to variable name */
     /* Returns ptr to contents on success, NULL on failure */
#define setenv(name, contents) setenvbin(name, contents, strlen(contents)+1)
     /* Writes n bytes from contents to variable name */
     /* Returns ptr to contents on success, NULL on failure */
char *setenvbin(const char *name, const char *contents, int n);
     /* Converts hexadecimal value to unsigned long */
#define xtol(s) ((unsigned long) strtol((s),(char **)0, 16))
     /* Converts long to hexadecimal string, returns ptr to following NULL */
char *ltox(char *a, unsigned long value);
     /* Converts long to 10-based string, returns ptr to following NULL */
char *ltoa(char *a, long l);
     /* Converts int to 10-based string, returns ptr to following NULL */
#define itoa(l) (ltoa((long)(l)))
     /* Copies len bytes from s to d, handles overlapping correctly */
void bcopy(const char *s, char *d, int len);
#endif

#define RAND_MAX	((1 << (8*sizeof(int)-1)) - 1)

/* Private structures, do _not_ touch! */
extern struct List _memlist;
extern void (*__exitfunc)(void);     /* User function set with atexit() */
