#include <stdio.h>
#include <stdlib.h>
#include <exec/types.h>
#include <exec/lists.h>
#include <dos/dos.h>
#include <exec/exec_protos.h>
#include <dos/dos_protos.h>

#define ITEMS 1000

void PrintList(struct List *l)
{
    struct Node *curr;

    printf("PL:");
    curr = HeadNode(l);

    while (curr)
    {
	printf(" %8x", curr);
	curr = NextNode(curr);
    }
    printf("\n");
}



void TestLists(void)
{
    struct List MyList;
    struct Node *n;

    NewList(&MyList);
    PrintList(&MyList);

    n = malloc(sizeof(struct Node));
    AddHead(&MyList, n);
    PrintList(&MyList);

    n = malloc(sizeof(struct Node));
    AddHead(&MyList, n);
    PrintList(&MyList);

    n = malloc(sizeof(struct Node));
    AddTail(&MyList, n);
    PrintList(&MyList);

    n = malloc(sizeof(struct Node));
    AddTail(&MyList, n);
    n = malloc(sizeof(struct Node));
    AddTail(&MyList, n);
    n = malloc(sizeof(struct Node));
    AddTail(&MyList, n);
    n = malloc(sizeof(struct Node));
    AddTail(&MyList, n);
    n = malloc(sizeof(struct Node));
    AddTail(&MyList, n);
    PrintList(&MyList);

    RemHead(&MyList);
    PrintList(&MyList);

    RemTail(&MyList);
    PrintList(&MyList);

    while (n = HeadNode(&MyList))
    {
	Remove(n);
	PrintList(&MyList);
    }
}



int main(int argc, char **argv)
{
    static unsigned short taulu1[1000], taulu2[1000], taulu3[1000];
    int i/*, brkline*/;
    FILE *fp;
    APTR fph;

    if (argc < 2)
    {
        fprintf(stderr, "Usage:\n%s TestFile\n", argv[0]);
        return 20;
    }

    srand(1234);

    for (i=0; i<1000; i++)
    {
	taulu1[i] = rand();
	taulu2[i] = rand();
	taulu1[i] = i+8;
	taulu2[i] = i+1024;

    }

    if (!(fp = fopen(argv[1], "wb")))
    {
        fprintf(stderr, "%s: Couldn't open file %s for writing!\n",
                argv[0], argv[1]);
        return 20;
    }

    if ((i = fwrite(taulu1, sizeof(short), ITEMS, fp)) != ITEMS)
    {
        fprintf(stderr, "%s: Could write only %d items of taulu1!\n",
                argv[0], i);
        return 20;
    }

    if ((i = fwrite(taulu2, sizeof(short), ITEMS, fp)) != ITEMS)
    {
        fprintf(stderr, "%s: Could write only %d items of taulu2!\n",
                argv[0], i);
        return 20;
    }

    fclose(fp);


    if (!(fp = fopen(argv[1], "rb")))
    {
        fprintf(stderr, "%s: Couldn't open file %s for reading!\n",
                argv[0], argv[1]);
        return 20;
    }

    if ((i = fread(taulu3, sizeof(short), ITEMS, fp)) != ITEMS)
    {
        fprintf(stderr, "%s: Could read only %d items of taulu1 to taulu3!\n",
                argv[0], i);
        return 20;
    }

    for (i=0; i<ITEMS; i++)
    {
	if (taulu1[i] != taulu3[i])
	    fprintf(stderr, "%s: taulu1[%d] = %d, taulu3[%d] = %d!!!\n",
		    argv[0], i, taulu1[i], i, taulu3[i]);
    }

    if ((i = fread(taulu3, sizeof(short), ITEMS, fp)) != ITEMS)
    {
        fprintf(stderr, "%s: Could read only %d items of taulu1 to taulu3!\n",
                argv[0], i);
        return 20;
    }

    for (i=0; i<ITEMS; i++)
    {
	if (taulu2[i] != taulu3[i])
	    fprintf(stderr, "%s: taulu2[%d] = %d, taulu3[%d] = %d!!!\n",
		    argv[0], i, taulu2[i], i, taulu3[i]);
    }

    fclose(fp);

    printf("First pass finished...\n");

    if (!(fp = fopen(argv[1], "rb")))
    {
        fprintf(stderr, "%s: Couldn't open file %s for reading!\n",
                argv[0], argv[1]);
        return 20;
    }

    for (i=0; i<ITEMS; i++)
	taulu3[i] = fgetc(fp) << 8 | fgetc(fp);

    for (i=0; i<ITEMS; i++)
    {
	if (taulu1[i] != taulu3[i])
	    fprintf(stderr, "%s: taulu1[%d] = %d, taulu3[%d] = %d!!!\n",
		    argv[0], i, taulu1[i], i, taulu3[i]);
    }

    for (i=0; i<ITEMS; i++)
	taulu3[i] = fgetc(fp) << 8 | fgetc(fp);

    for (i=0; i<ITEMS; i++)
    {
	if (taulu2[i] != taulu3[i])
	    fprintf(stderr, "%s: taulu2[%d] = %d, taulu3[%d] = %d!!!\n",
		    argv[0], i, taulu2[i], i, taulu3[i]);
    }


    fclose(fp);

    printf("Second pass finished...\n");





    if (!(fph = Open(argv[1], MODE_OLDFILE)))
    {
        fprintf(stderr, "%s: Couldn't open file %s for reading!\n",
                argv[0], argv[1]);
        return 20;
    }

    Read(fph, (char *) taulu3, sizeof(short) * ITEMS);

    for (i=0; i<ITEMS; i++)
    {
	if (taulu1[i] != taulu3[i])
	    fprintf(stderr, "%s: taulu1[%d] = %d, taulu3[%d] = %d!!!\n",
		    argv[0], i, taulu1[i], i, taulu3[i]);
    }

    Read(fph, (char *) taulu3, sizeof(short) * ITEMS);

    for (i=0; i<ITEMS; i++)
    {
	if (taulu2[i] != taulu3[i])
	    fprintf(stderr, "%s: taulu2[%d] = %d, taulu3[%d] = %d!!!\n",
		    argv[0], i, taulu2[i], i, taulu3[i]);
    }


    Close(fph);

    printf("Third pass finished...\n");

/*
    if(argc>=3)
	brkline = atoi(argv[2]);
    else
	brkline = -1;

    i = 0;
    while(!(SetSignal(0, SIGF_CTRL_C) & SIGF_CTRL_C) && i++ < 1000)
    {
	static char huihai[80];

	if(i == brkline)
	    SetSignal(SIGF_CTRL_C, SIGF_CTRL_C);
	sprintf(huihai, "Testirivi n:o %d\n", i);
	Write(Output(), huihai, strlen(huihai));
    }
*/

    TestLists();

    return 0;
}
